.\"	$OpenBSD: ldconfig.8,v 1.26 2013/03/20 21:49:59 kurt Exp $
.\"
.\" Copyright (c) 1993,1995 Paul Kranenburg
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by Paul Kranenburg.
.\" 3. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\"
.Dd $Mdocdate: March 20 2013 $
.Dt LDCONFIG 8
.Os
.Sh NAME
.Nm ldconfig
.Nd configure the shared library cache
.Sh SYNOPSIS
.Nm ldconfig
.Op Fl DmPRrSsUv
.Op Ar path ...
.Sh DESCRIPTION
.Nm
is used to prepare a set of
.Dq hints
for use by the run-time linker
.Xr ld.so 1
to facilitate quick lookup of shared libraries available in multiple
directories.
It scans a set of built-in system directories and any
.Ar directories
specified on the command line (in the given order) looking for shared
libraries and stores the results in the file
.Pa /var/run/ld.so.hints
to forestall the overhead that would otherwise result from the
directory search operations
.Xr ld.so 1
would have to perform to load the required shared libraries.
.Pp
The shared libraries so found will be automatically available for loading
if needed by the program being prepared for execution.
This obviates the need for storing search paths within the executable.
.Pp
The
.Ev LD_LIBRARY_PATH
environment variable can be used to override the use of
directories (or the order thereof) from the cache or to specify additional
directories where shared libraries might be found.
.Ev LD_LIBRARY_PATH
is a
.Sq \&:
separated list of directory paths which are searched by
.Xr ld.so 1
when it needs to load a shared library.
It can be viewed as the run-time equivalent of the
.Fl L
switch of
.Xr ld 1 .
.Pp
.Nm
is typically run as part of the boot sequence.
In addition to the built-in system directories,
directories containing shared libraries may be specified via the
.Ev shlib_dirs
variable in
.Pa /etc/rc.conf.local .
See
.Xr rc.conf 8
for further information.
.Pp
The following options are recognized by
.Nm ldconfig :
.Bl -tag -width indent
.It Fl D
Remove any prebind information in the specified binary or shared library.
.It Fl m
Merge the result of the scan of the directories given as arguments into
the existing hints file.
The default action is to build the hints file afresh.
This option cannot be used with
.Fl U .
.It Fl P
Create and append prebind information to all executables found in
the specified directories, and also all shared libraries which are
required by those executables.
.It Fl R
Rescan the previously configured directories.
This opens the hints file and fetches the directory list from the header.
Any additional pathnames on the command line are also processed.
.It Fl r
List the current contents of
.Pa ld.so.hints
on the standard output.
The hints file will not be modified.
.It Fl S
Perform prelinking operations in a safe mode; always copies the binaries
when prelinking data is added to a file.
Use this to eliminate the possibility that
.Dv ETXTBUSY
will occur when attempting to run a binary while prelinking
is running.
.It Fl s
Do not scan the built-in system directory
.Pq Dq /usr/lib
for shared libraries.
.It Fl U
Unconfigure directories specified on the command line or remove inaccessible
directories from search path if no directories specified.
This option cannot be used with
.Fl m .
.It Fl v
Switch on verbose mode.
.El
.Sh PREBINDING
Prebinding is loosely based on an earlier concept called Prelinking, which
also accelerated
.Xr ld.so 1
performance but simultaneously impaired address space randomization.
When prebinding information is added to libraries and programs using
.Fl P ,
program startup can be significantly improved because
.Xr ld.so 1
can initialize the shared library environment much faster.
Prebinding information adds a small amount of data to the end of each
specified program and associated shared libraries.
.Sh SECURITY
Special care must be taken when loading shared libraries into the address
space of
.Ev set-user-Id
programs.
Whenever such a program is run,
.Xr ld.so 1
will only load shared libraries from the
.Pa ld.so.hints
file.
In particular, the
.Ev LD_LIBRARY_PATH
is not used to search for libraries.
Thus, the role of
.Nm
is dual.
In addition to building a set of hints for quick lookup, it also serves to
specify the trusted collection of directories from which shared objects can
be safely loaded.
It is presumed that the set of directories specified to
.Nm
are under control of the system's administrator.
.Xr ld.so 1
further assists set-user-Id programs by erasing the
.Ev LD_LIBRARY_PATH
from the environment.
.Sh ENVIRONMENT
.Bl -tag -width Ds
.It Ev LD_LIBRARY_PATH
Additional directories containing shared libraries,
settable in the user's environment.
.It Ev shlib_dirs
Additional directories containing shared libraries,
settable in
.Pa /etc/rc.conf.local .
.El
.Sh FILES
.Bl -tag -width Ds -compact
.It Pa /etc/rc.conf
.It Pa /etc/rc.conf.local
.It Pa /var/run/ld.so.hints
.El
.Sh SEE ALSO
.Xr ld 1 ,
.Xr link 5 ,
.Xr rc.conf 8
.Sh HISTORY
An
.Nm
utility first appeared in SunOS 4.0.
It appeared in its current form in
.Nx 0.9a .
